﻿using UnityEngine;

public class TestGadget : Gadget
{
    /// \copydoc Gadget.s_type
    [Newtonsoft.Json.JsonProperty]
    protected static new string s_type = "TestGadget";


    protected override void _Hit(RaycastHit[] hit)
    {
        // string pid = FactAdder.AddPointFact(hit[0], gadget: this).Id;
        string pid = ((TestPointFact) FactAdder.AddFactIfNotFound(new TestPointFact(hit[0].point, hit[0].normal), out _, false, this, null)).Id;

        for (int i = 0; i < hit.Length; i++)
        {
            if (!Mathf.Approximately(hit[0].distance, hit[i].distance))
                break;

            if (hit[i].transform.gameObject.layer == LayerMask.NameToLayer("Ray"))
            {
                Workflow.Add(hit[i].transform.GetComponent<FactObject>().URI);
                FactAdder.AddOnLineFact
                    (pid
                    , Workflow[i]
                    , samestep: true
                    , gadget: this
                    , is_certain: false);
            }
        }

        ResetGadget();
    }
}
